#!/usr/bin/perl

$|=1;
$ENFORCEMENT="1";
$DATA_PATH="./";
$PIXEL_SCALE=120;


   &grep_hunt; 
   &parse_input;
   &validate;
   &load_colors;

   if ($fields{'action'} eq "VIEW")
    {
      &view_results;
      exit;
    }

   if ($fields{'action'} eq "VOTE")
    {
    &is_repeater;
    if ($REPEATER eq "0") 
     {
       $tmp_lock="$fields{'filebase'}.lock";
       &LockIt ("$tmp_lock");
       &get_unique;
       &write_data;
       &UnLockIt ("$tmp_lock");
     }
      &view_results;
      exit;
    }

####This subroutine creates the HTML code result of the survey data
sub view_results
{
   &get_sample_size;
   $j=0;
   @tmp_cnt=();
   &print_head;
   &get_list;
   foreach (@to_get)
    {
      @label_text=();
      $get_it=@to_get[$j];
      &get_labels;
      &read_data;
      &find_max;
      $i=0;
			print "<TABLE BORDER=0 cellpadding=5 cellspacing=0 width=100%><tr><td bgcolor=black><font color=white><b>@label_text[1]</b></font></td></tr>";
			print "<tr><td bgcolor=#e3e3e3><font color=black>`ǥ : </font><font color=#cc0000><b>$ssize</b></font></td></tr>";

   if ($fields{'action'} eq "VOTE")
    {
      if ($REPEATER eq "0")
       {
         print "";
       }
       else
       {

### Ʒ vote(s)  湮  vote(s)  쿡 ִ ؽƮԴϴ.
### ׳ νô Ͻô  ϼ~ :)

        print "<tr><td bgcolor=#e3e3e3 align=center><font color=#0000cc>zwL@ФŭЦb</font></td></tr>";
       }
    }

   print "</table><br><TABLE BORDER=0 bgcolor=#f3f3f3 cellpadding=4 cellspacing=0 width=100%>";
      foreach (@tmp_cnt)
       {
         $lab=@label_text[$i+2];
         $wide=int(@tmp_cnt[$i] * $factor);
         $colr=@colors[$i];
         $pct=int((@tmp_cnt[$i]/$ssize)*100);
         print " <TR align=center>\n";
         if (@tmp_cnt[$i] > 0)
           {
            print "<TD align=left>$lab<br><IMG SRC=\"$colr\" ";
            print " BORDER=0 HEIGHT=8 WIDTH=$wide>\n";
		        print "<font color=black><b>$pct\%</b> (<b>@tmp_cnt[$i]</b> ǥ)</font>";						
           }
           else
           {
            print "<TD align=left>$lab<br>\n";
	          print "<font color=black><b>$pct\%</b> (<b>0</b>vote(s))</font>";						
           }

         print "<br><br></TD>";
         print " </TR>\n";
         $i++;
       }
      print "</TABLE><center><font color=black>{<A HREF=\"javascript:history.go(-1)\">Back</a>}</font></center>";

			print "<br><TABLE BORDER=0 bgcolor=#f3f3f3 cellpadding=5 cellspacing=0 width=100%><tr><td align=center><font class=ver8>Created by <A HREF=\"http://bignosebird.com/\" target=_blank><B><font color=black class=ver8>BigNoseBird.Com</font></B></A><br>Modified By <B><font class=ver8><A HREF=\"http://zodiac.woorizip.com/\" target=_blank>Zodiac</a></font></td></tr></table></body></html>\n";
      @tmp_cnt=();
      $j++;
    }

}

###READ IN THE TEXT INFORMATION FILE FOR HEADINGS AND LABELS
sub get_labels
{
   open(TEXT_FILE,"$GREP $get_it: $DATA_PATH$textsource|");
    while ($tx_rec=<TEXT_FILE>)
     {
       chop $tx_rec;
       @label_text = split(/:/,$tx_rec);
     }
     close(TEXT_FILE);
}

###READ THE SURVEY RESULTS FILE
sub read_data
{
   open(DATA_FILE,"$GREP $get_it: $DATA_PATH$datasource|");
    while ($in_rec=<DATA_FILE>)
     {
       chop $in_rec;
       @rec = split(/:/,$in_rec);
       @tmp_cnt[@rec[1]]++;
     }
   close DATA_FILE;
}

###FOR EACH QUESTION, FIND THE MAX VALUE AND SCALE THE RESULT IN PIXELS
sub find_max
{
   $b=0;
   $factor=1;
   $maxwide=1;
   foreach (@tmp_cnt)
    {
     if (@tmp_cnt[$b] > $maxwide)
       {
         $maxwide = @tmp_cnt[$b];
       }
     $b++;
    }
   $factor = $PIXEL_SCALE/$maxwide;
}

sub load_colors
{
   @colors=("teal.gif","teal.gif","teal.gif",
            "teal.gif","teal.gif", "teal.gif",
            "teal.gif","teal.gif","teal.gif",
            "teal.gif",
            "teal.gif","teal.gif","teal.gif",
            "teal.gif","teal.gif", "teal.gif",
            "teal.gif","teal.gif","teal.gif",
            "teal.gif");
}


sub print_head
{


print "Content-type: text/html\n\n";
print "<HTML>";
print "<title>Vote</title>";
print "<style>";
print "body,td,select,input,div,form,textarea,center {font-size:10pt;}";
print "p,blockquote,br {font-size:10pt}";
print ".ver8 {font-family:Verdana,Arial;font-size:8pt}";
print "A:link    {color:black;font-size:10pt;text-decoration:none;}";
print "A:visited {color:black;font-size:10pt;text-decoration:none;}";
print "A:active  {color:black;font-size:10pt}";
print "A:hover  {color:silver;text-decoration:none;}";
print "</style>";
print "<BODY BGCOLOR=#f3f3f3 leftmargin=0 topmargin=0 marginheight=0 marginwidth=0><center>";

}


sub get_list
{
   $x=0;
   open(TEXT_FILE,"<$DATA_PATH$textsource");
    while ($tx_rec=<TEXT_FILE>)
     {
       chop $tx_rec;
       if ($tx_rec eq "")
         {
          next;
         }
       @to_get[$x] = split(/:/,$tx_rec,2);
       $x++;
     }
     close(TEXT_FILE);
}

###Decode the input string
sub parse_input
{
  $k=0;
  read(STDIN,$temp,$ENV{'CONTENT_LENGTH'});
  @pairs=split(/&/,$temp);
  foreach $item(@pairs)
   {
    ($key,$content)=split(/=/,$item,2);
    $content=~tr/+/ /;
    $content=~s/%(..)/pack("c",hex($1))/ge;
    $fields{$key}=$content;
    $k++;
    $item{$k}=$key;
    $response{$k}=$content;
   }
   $user_id= $ENV{'REMOTE_ADDR'};
   $datasource="$fields{'filebase'}.dat";
   $textsource="$fields{'filebase'}.cfg";
   $cntsource ="$fields{'filebase'}.cnt";
   $logsource ="$fields{'filebase'}.log";
}

###Send our output to the screen, log, and datafile
sub write_data
{
   $z=1;
   open(DATA_OUT,">>$DATA_PATH$datasource");
   open(LOG_OUT,">>$DATA_PATH$logsource");
   print LOG_OUT "$unique:$user_id:";
   print LOG_OUT "$day:$month:$num:$year:$hour:$minute:$second:";
   while ( $item{$z} gt " ")
    {                                                 
     if ( $item{$z} ne "action" && $item{$z} ne "filebase" )
      {
       print DATA_OUT "$item{$z}:$response{$z}\n"; 
       print LOG_OUT  "$item{$z}:$response{$z}:"; 
       print "$item{$z}:$response{$z}\n"; 
      }
     $z++;                                           
    }
   print LOG_OUT "\n";
   close(DATA_OUT);
   close(LOG_OUT);
}

###Before doing anything, make sure we have a valid call
sub validate
{
   if ($fields{'filebase'} eq "")
    {
      print "Content-type: text/html\n\n";
      print "Error.\n";
    }
   if ($fields{'action'} eq "")
    {
      print "Content-type: text/html\n\n";
      print "Error.\n";
    }
}

###This gets us a unique number to assign each survey entry
sub get_unique
{
   $cntsource ="$fields{'filebase'}.cnt";
    open(CNT,"<$DATA_PATH$cntsource");
    while ($unique=<CNT>)
     {
       if ( $unique lt "1")
        {
          $unique=0;
        } 
        last;
     }
    $unique++;
    close(CNT);
    open(CNT,">$DATA_PATH$cntsource");
    print CNT "$unique";
    close(CNT);    
}

#Derive all the elements of the current date and time
sub get_time
{
 $date=localtime(time);
 ($day, $month, $num, $time, $year) = split(/\s+/,$date);
 ($hour, $minute, $second) = split(/:/,$time);
}


### Lock the files (this routine borrowed from Selena Sol!)
sub LockIt {  
    local ($lock_file) = @_;

    local ($endtime);  
    $endtime = 60;
    $endtime = time + $endtime;
#   We set endtime to wait 60 seconds

    while (-e $lock_file && time < $endtime) {
        # Do Nothing
    }
    open(LOCK_FILE, ">$DATA_PATH$lock_file");    
#    flock(LOCK_FILE, 2); # 2 exclusively locks the file
} # end of get_file_lock

### Unlock the files (this routine borrowed from Selena Sol!)
sub UnLockIt {
    local ($lock_file) = @_;
       
# 8 unlocks the file
#    flock(LOCK_FILE, 8);
    close(LOCK_FILE);
    unlink($lock_file);

} # end of ReleaseFileLock   

###Grab the sample size from the counter file so we can do percentages
sub get_sample_size
{
   $cntsource ="$fields{'filebase'}.cnt";
    open(CNT,"<$DATA_PATH$cntsource");
    while ($ssize=<CNT>)
     {
       if ( $ssize lt "1")
        {
          $ssize=1;
        } 
        last;
    }
    close(CNT);
}

###This routine looks at the log to see if this IP address has made
###an entry during the current clock hour on this day.
###If ENFORCEMENT is turned on and a record is found, then REPEATER
###is set to 1, otherwise REPEATER is set to 0.
sub is_repeater
{
   &get_time;
   $REPEATER="0";
   if ($ENFORCEMENT eq "1")
    {

### Ʒ    vote(s) ׿  vote(s)  ϰ Ͽ ,
###     ϴ κԴϴ.
### Ʒ ҽ ״ νø Ϸ翡 ѹۿ vote(s)  մϴ.
###  ð뿡 ѹۿ vote(s)  ϰ Ϸ,
### open(LOG_IN,"$GREP ':$user_id:$day:$month:$num:$year:$hour:' $DATA_PATH$logsource|");
###  ޿ ѹۿ vote(s)  ϰ Ϸ,
### open(LOG_IN,"$GREP ':$user_id:$day:$month:' $DATA_PATH$logsource|");
###  ֽø ˴ϴ.

     open(LOG_IN,"$GREP ':$user_id:$day:' $DATA_PATH$logsource|");
		 
     while ($dup_check=<LOG_IN>)
      {
         chop $dup_check;
         $REPEATER=1;
      }
     close(LOG_IN);
   }
}

#id_number:IP_addr:Weekday:Mnth:Day:Yr:Hr:min:sec:ITEM1:value:ITEM2:value:


sub grep_hunt
{
  if ( -e "/bin/fgrep")
   {$GREP="/bin/fgrep"; return;}

  if ( -e "/bin/grep")
   {$GREP="/bin/grep"; return;}

  if ( -e "/usr/bin/grep")
   {$GREP="/usr/bin/grep"; return;}

  if ( -e "/sbin/fgrep")
   {$GREP="/sbin/fgrep"; return;}

  if ( -e "/usr/sbin/fgrep")
   {$GREP="/usr/sbin/fgrep"; return;}

  if ( -e "/usr/bin/fgrep")
   {$GREP="/usr/bin/fgrep"; return;}

  if ( -e "/usr/sbin/grep")
   {$GREP="/usr/sbin/grep"; return;}

  if ( -e "/sbin/grep")
   {$GREP="/sbin/grep"; return;}

   print "Content-type: text/html\n\n";
   print "ERROR! Unable to find grep utility.\n";

#if grep on your system is not in the list above,
#change one of the $GREP= to be equal to your 
#system's grep command.

}

